﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Linq;
using System.Net;
using System.Runtime.InteropServices;
using System.Text;
using System.Text.RegularExpressions;
using System.Threading;
using System.Windows.Forms;

namespace 舔狗模拟器
{
    public partial class ChatPage : Form
    {
        public ChatPage(bool tg,string name,string name2)
        {
            InitializeComponent();
            msgs = new List<KeyValuePair<string, string>>();
            this.tg = tg;
            this.name = name;
            this.name2 = name2;
            label1.Text = name+"(在线)";
            SetShadow();
        }

        private const int CS_DropSHADOW = 0x20000;
        private const int GCL_STYLE = (-26);
        [DllImport("user32.dll", CharSet = CharSet.Auto)]
        public static extern int SetClassLong(IntPtr hwnd, int nIndex, int dwNewLong);
        [DllImport("user32.dll", CharSet = CharSet.Auto)]
        public static extern int GetClassLong(IntPtr hwnd, int nIndex);

        private void SetShadow()
        {
            SetClassLong(this.Handle, GCL_STYLE, GetClassLong(this.Handle, GCL_STYLE) | CS_DropSHADOW);
        }


        private void panel1_Paint(object sender, PaintEventArgs e)
        {
            LinearGradientBrush brush = new LinearGradientBrush(new Rectangle(panel1.Location, panel1.Size), Color.FromArgb(76, 139, 255), Color.FromArgb(31, 210, 255), LinearGradientMode.Horizontal);
            e.Graphics.FillRectangle(brush, e.ClipRectangle);
        }

        #region 无边框拖动效果
        [DllImport("user32.dll")]//拖动无窗体的控件
        public static extern bool ReleaseCapture();
        [DllImport("user32.dll")]
        public static extern bool SendMessage(IntPtr hwnd, int wMsg, int wParam, int lParam);
        public const int WM_SYSCOMMAND = 0x0112;
        public const int SC_MOVE = 0xF010;
        public const int HTCAPTION = 0x0002;

        private void FormMouseDown(object sender, MouseEventArgs e)
        {
            //拖动窗体
            ReleaseCapture();
            SendMessage(this.Handle, WM_SYSCOMMAND, SC_MOVE + HTCAPTION, 0);
        }
        #endregion

        private void panel2_Paint(object sender, PaintEventArgs e)
        {
            ControlPaint.DrawBorder(e.Graphics, panel2.ClientRectangle,
Color.FromArgb(235, 235, 235), 0, ButtonBorderStyle.Solid,
Color.FromArgb(235, 235, 235), 1, ButtonBorderStyle.Solid,
Color.FromArgb(235, 235, 235), 0, ButtonBorderStyle.Solid,
Color.FromArgb(235, 235, 235), 0, ButtonBorderStyle.Solid);
        }

        private void Form1_Resize(object sender, EventArgs e)
        {
            System.Drawing.Drawing2D.GraphicsPath FormPath;
            FormPath = new System.Drawing.Drawing2D.GraphicsPath();
            Rectangle rect = new Rectangle(0, 0, this.Width, this.Height);
            FormPath = GetRoundedRectPath(rect, 1);
            this.Region = new Region(FormPath);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="rect">窗体大小</param>
        /// <param name="radius">圆角大小</param>
        /// <returns></returns>
        private GraphicsPath GetRoundedRectPath(Rectangle rect, int radius)
        {
            int diameter = 5;
            Rectangle arcRect = new Rectangle(rect.Location, new Size(diameter, diameter));
            GraphicsPath path = new GraphicsPath();

            path.AddArc(arcRect, 180, 90);//左上角

            arcRect.X = rect.Right - diameter;//右上角
            path.AddArc(arcRect, 270, 90);

            arcRect.Y = rect.Bottom - diameter;// 右下角
            path.AddArc(arcRect, 0, 90);

            arcRect.X = rect.Left;// 左下角
            path.AddArc(arcRect, 90, 90);
            path.CloseFigure();
            return path;
        }


        private void Form1_Paint(object sender, PaintEventArgs e)
        {
            System.Drawing.Drawing2D.GraphicsPath FormPath;
            FormPath = new System.Drawing.Drawing2D.GraphicsPath();
            Rectangle rect = new Rectangle(0, 0, this.Width, this.Height);
            FormPath = GetRoundedRectPath(rect, 1);
            this.Region = new Region(FormPath);
        }

        private void panel4_Paint(object sender, PaintEventArgs e)
        {
            int cornerRadius = 3;
            //边框颜色
            Color c = Color.FromArgb(156, 156, 156);
            Pen p = new Pen(c);
            //边框工作区
            Rectangle rect = this.ClientRectangle;
            GraphicsPath Rect = new GraphicsPath();
            // 添加圆弧
            Rect.AddArc(0, 0, cornerRadius * 2, cornerRadius * 2, 180, 90);
            Rect.AddArc(rect.Width - cornerRadius * 2 - 1, 0, cornerRadius * 2, cornerRadius * 2, 270, 90);
            Rect.AddArc(rect.Width - cornerRadius * 2 - 1, rect.Height - cornerRadius * 2 - 1, cornerRadius * 2, cornerRadius * 2, 0, 90);
            Rect.AddArc(0, rect.Height - cornerRadius * 2 - 1, cornerRadius * 2, cornerRadius * 2, 90, 90);
            Rect.CloseFigure();
            e.Graphics.DrawPath(p, Rect);
        }

        private void label4_Click(object sender, EventArgs e)
        {

        }

        private void pictureBox2_MouseEnter(object sender, EventArgs e)
        {
            var ctrl = (sender as Control);
            ctrl.BackColor = Color.FromArgb(255, 84, 57);
        }

        private void pictureBox2_MouseLeave(object sender, EventArgs e)
        {
            var ctrl = (sender as Control);
            ctrl.BackColor = Color.Transparent;
        }

        private void pictureBox2_MouseDown(object sender, MouseEventArgs e)
        {
            var ctrl = (sender as Control);
            ctrl.BackColor = Color.FromArgb(224, 74, 50);
        }

        private void pictureBox2_MouseUp(object sender, MouseEventArgs e)
        {
            var ctrl = (sender as Control);
            ctrl.BackColor = Color.FromArgb(255, 84, 57);
        }

        private void pictureBox2_Click(object sender, EventArgs e)
        {
            Process.GetCurrentProcess().Kill();
        }

        private void pictureBox3_MouseEnter(object sender, EventArgs e)
        {
            var ctrl = (sender as Control);
            ctrl.BackColor = Color.FromArgb(79, 218, 254);
        }

        private void pictureBox3_MouseDown(object sender, MouseEventArgs e)
        {
            var ctrl = (sender as Control);
            ctrl.BackColor = Color.FromArgb(110, 224, 254);
        }

        private void pictureBox3_MouseUp(object sender, MouseEventArgs e)
        {
            var ctrl = (sender as Control);
            ctrl.BackColor = Color.FromArgb(79, 218, 254);
        }

        private void pictureBox3_MouseLeave(object sender, EventArgs e)
        {
            var ctrl = (sender as Control);
            ctrl.BackColor = Color.Transparent;
        }

        private void ChatPage_Load(object sender, EventArgs e)
        {
            webBrowser1.DocumentText = Properties.Resources.Html;
            webBrowser1.ContextMenuStrip = null;
            if (tg)
                ReceiveMsg += ChatPage_ReceiveMsg;
            else
            {
                Action sendMsg = new Action(() =>
                {
                    while (true)
                    {
                        Thread.Sleep(3000);
                        this.Invoke(new Action(() =>
                        {
                            label1.Text = name + "(正在输入...)";
                        }));
                        if (msgs.Where(x => x.Key == "agent").Count() >= 30)
                        {
                            this.Invoke(new Action(() =>
                            {
                                Say("对不起...");
                                Say("哎...,祝你幸福吧!");
                                label1.Text = name + "(离线)";
                            }));
                            return;
                        }
                        Thread.Sleep(new Random().Next(50, 200) * 10);
                        this.Invoke(new Action(() =>
                        {
                            Say(Msg.tgList[new Random().Next(0, Msg.tgList.Count)].Replace("%name%", name2));
                            label1.Text = name + "(在线)";
                        }));
                        Thread.Sleep(new Random().Next(50, 500) * 10);
                    }
                });
                sendMsg.BeginInvoke(ar => sendMsg.EndInvoke(ar), null);
            }
        }

        public List<KeyValuePair<string,string>> msgs { get; set; }

        public bool tg { get; set; }

        private void ChatPage_ReceiveMsg(object sender, EventArgs e)
        {
            Action action = new Action(() =>
            {
                var msg = sender.ToString();
                if (tg)
                {
                    if(new Random().Next(0, 10) < 7) {
                        Thread.Sleep(new Random().Next(100, 300) * 10);
                        if (msg.StartsWith("在吗") || msg.StartsWith("在嘛"))
                        {
                            if (new Random().Next(0, 10) > 5)
                            {
                                this.Invoke(new Action(() =>
                                {
                                    label1.Text = name + "(正在输入中...)";
                                }));
                                Thread.Sleep(new Random().Next(100, 300) * 10);
                                this.Invoke(new Action(() =>
                                {
                                    Say("问问问，天天就知道问在不在，头都给你锤爆！");
                                    Thread.Sleep(new Random().Next(100, 300) * 10);
                                    Say("下线了拜拜！");
                                    label1.Text = name + "(离线)";
                                    this.ReceiveMsg -= ChatPage_ReceiveMsg;
                                }));
                            }
                            else
                            {
                                this.Invoke(new Action(() =>
                                {
                                    label1.Text = name + "(正在输入中...)";
                                }));
                                Thread.Sleep(new Random().Next(100, 300) * 10);
                                this.Invoke(new Action(() =>
                                {
                                    Say(Msg.replyList[new Random().Next(0, Msg.replyList.Count)]);
                                }));
                                this.Invoke(new Action(() =>
                                {
                                    label1.Text = name + "(在线)";
                                }));
                            }
                        }
                        else
                        {
                            if (new Random().Next(0, 10) >= 7)
                            {
                                try
                                {
                                    var webClient = new WebClient();
                                    webClient.Encoding = Encoding.UTF8;
                                    string content = webClient.DownloadString("http://www.nows.fun/");
                                    content = Regex.Match(content, "id=\"sentence\".*?>(.*?)<").Groups[1].Value;
                                    if(content.Contains("你"))
                                    {
                                        this.Invoke(new Action(() =>
                                        {
                                            label1.Text = name + "(正在输入中...)";
                                        }));
                                        Thread.Sleep(new Random().Next(100, 300) * 10);
                                        this.Invoke(new Action(() =>
                                        {
                                            Say(content.Replace("你", "你\"" + name2 + "\""));
                                        }));
                                        this.Invoke(new Action(() =>
                                        {
                                            label1.Text = name + "(在线)";
                                        }));
                                    }
                                }
                                catch (Exception)
                                {

                                    throw;
                                }
                            }
                            else
                            {
                                this.Invoke(new Action(() =>
                                {
                                    label1.Text = name + "(正在输入中...)";
                                }));
                                Thread.Sleep(new Random().Next(100, 300) * 10);
                                this.Invoke(new Action(() =>
                                {
                                    Say(Msg.replyList[new Random().Next(0, Msg.replyList.Count)].Replace("%name%", name2));
                                }));
                                this.Invoke(new Action(() =>
                                {
                                    label1.Text = name + "(在线)";
                                }));
                            }
                        }
                    }
                    else
                    {

                    }
                }
            });
            action.BeginInvoke(ar => action.EndInvoke(ar), null);
        }

        public void Say(string msg)
        {
            string str = @"
<div class=""msg-agent"">
                  <div  class=""date""></div>
                <div class=""bubble"">
                  <span class=""arrow-bg""></span>
                  <span class=""arrow""></span>
                  <div class=""text"">" + msg + @"</div></div>
              </div>
<a id='ok'></a>";
            str += "<a id='ok'></a>";
            webBrowser1.Document.GetElementById("ok").OuterHtml = str;
            webBrowser1.Document.InvokeScript("goBottom");
            msgs.Add(new KeyValuePair<string, string>("agent", msg));
        }

        private void pictureBox1_MouseEnter(object sender, EventArgs e)
        {
            pictureBox1.Image = Properties.Resources.关闭_Hover;
        }

        private void pictureBox1_MouseLeave(object sender, EventArgs e)
        {
            pictureBox1.Image = Properties.Resources.关闭_Normal;
        }

        private void pictureBox1_MouseDown(object sender, MouseEventArgs e)
        {
            pictureBox1.Image = Properties.Resources.关闭_Down;
        }

        private void pictureBox1_MouseUp(object sender, MouseEventArgs e)
        {
            pictureBox1.Image = Properties.Resources.关闭_Hover;
        }

        private void pictureBox1_Click(object sender, EventArgs e)
        {
            Process.GetCurrentProcess().Kill();
        }

        private void pictureBox5_MouseEnter(object sender, EventArgs e)
        {
            pictureBox5.Image = Properties.Resources.发送_Hover;
        }

        private void pictureBox5_MouseDown(object sender, MouseEventArgs e)
        {
            pictureBox5.Image = Properties.Resources.发送_Down;
        }

        private void pictureBox5_MouseUp(object sender, MouseEventArgs e)
        {
            pictureBox5.Image = Properties.Resources.发送_Hover;
        }

        private void pictureBox5_MouseLeave(object sender, EventArgs e)
        {
            pictureBox5.Image = Properties.Resources.发送_Normal;
        }

        public event EventHandler ReceiveMsg;

        public string name { get; set; }

        public string name2 { get; set; }

        private void pictureBox5_Click(object sender, EventArgs e)
        {
            if (richTextBox1.Text.Replace(" ","").Length==0)
                return;
            string str = @"
<div class=""msg-client"">
                  <div  class=""date""></div>
                <div class=""bubble"">
                  <span class=""arrow-bg""></span>
                  <span class=""arrow""></span>
                  <div class=""text"">" + richTextBox1.Text.Replace("\n", "<br/>").Replace(" ", "&nbsp;") + @"</div></div>
              </div>
<a id='ok'></a>";
            str += "<a id='ok'></a>";
            msgs.Add(new KeyValuePair<string, string>("client", richTextBox1.Text));
            ReceiveMsg(richTextBox1.Text, null);
            richTextBox1.Text = string.Empty;
            webBrowser1.Document.GetElementById("ok").OuterHtml = str;
            webBrowser1.Document.InvokeScript("goBottom");
        }

        private void richTextBox1_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Enter)
            {
                pictureBox5_Click(sender, e);
            }
        }

        private void richTextBox1_KeyUp(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Enter)
                richTextBox1.Text = "";
        }
    }
}
